﻿using Syncfusion.WinForms.Controls;
using Syncfusion.WinForms.DataGrid.Styles;
using System.Windows.Forms;
using Syncfusion.WinForms.DataGrid.Enums;
using Syncfusion.WinForms.DataGrid.Interactivity;
using Syncfusion.WinForms.DataGrid;
using Syncfusion.WinForms.DataGrid.Renderers;
using System.Text.RegularExpressions;
using System;
using System.Linq;
using Syncfusion.WinForms.GridCommon.ScrollAxis;
using System.Drawing;
using Syncfusion.Data;
using System.Collections.ObjectModel;
using Syncfusion.WinForms.DataGrid.Data;
using System.Collections.Generic;
using Syncfusion.WinForms.DataGrid.Helpers;
using System.Windows.Forms.VisualStyles;
using Syncfusion.WinForms.DataGrid.Events;
using Syncfusion.WinForms.Core;
using Syncfusion.WinForms.Core.Enums;
using System.Reflection;

namespace GettingStarted
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            var data = new OrderInfoCollection();
            sfDataGrid.AutoGenerateColumns = false;
            sfDataGrid.DataSource = data.OrdersListDetails;
            this.sfDataGrid.Columns.Add(new GridNumericColumn() { MappingName = "OrderID" });
            this.sfDataGrid.Columns.Add(new GridTextColumn() { MappingName = "ProductName" });
            this.sfDataGrid.Columns.Add(new GridNumericColumn() { MappingName = "UnitPrice" });
            this.sfDataGrid.Columns.Add(new GridNumericColumn() { MappingName = "Quantity" });
            this.sfDataGrid.Columns.Add(new GridTextColumn() { MappingName = "CustomerID" });
            this.sfDataGrid.Columns.Add(new GridTextColumn() { MappingName = "ContactNumber" });

            //ShowRowInSummary = True
            //Creating Summary Columns
            GridSummaryColumn summaryColumn1 = new GridSummaryColumn();
            summaryColumn1.Name = "OrderID";
            summaryColumn1.SummaryType = SummaryType.CountAggregate;
            summaryColumn1.Format = "{Count}";
            summaryColumn1.MappingName = "OrderID";

            GridSummaryColumn summaryColumn2 = new GridSummaryColumn();
            summaryColumn2.Name = "Price";
            summaryColumn2.SummaryType = SummaryType.DoubleAggregate;
            summaryColumn2.Format = "{Sum}";
            summaryColumn2.MappingName = "UnitPrice";

            GridSummaryColumn summaryColumn3 = new GridSummaryColumn();
            summaryColumn3.Name = "Quantity";
            summaryColumn3.SummaryType = SummaryType.DoubleAggregate;
            summaryColumn3.Format = "{Average}";
            summaryColumn3.MappingName = "Quantity";

            //TableSummary Row
            GridTableSummaryRow tableSummaryRow1 = new GridTableSummaryRow();
            tableSummaryRow1.Name = "TableSummary";
            tableSummaryRow1.ShowSummaryInRow = true;
            tableSummaryRow1.Title = " Table Summary: Count - {OrderID} - Price - {Price} - Avg Quantity - {Quantity}";
            tableSummaryRow1.Position = VerticalPosition.Bottom;

            tableSummaryRow1.SummaryColumns.Add(summaryColumn1);
            tableSummaryRow1.SummaryColumns.Add(summaryColumn2);
            tableSummaryRow1.SummaryColumns.Add(summaryColumn3);
            this.sfDataGrid.TableSummaryRows.Add(tableSummaryRow1);

            //GroupSummary Row
            GridSummaryRow groupSummaryRow1 = new GridSummaryRow();
            groupSummaryRow1.Name = "GroupSummary";
            groupSummaryRow1.ShowSummaryInRow = true;
            groupSummaryRow1.Title = "Group Summary: Count - {OrderID} - Price - {Price} - Avg Quantity - {Quantity}";

            groupSummaryRow1.SummaryColumns.Add(summaryColumn1);
            groupSummaryRow1.SummaryColumns.Add(summaryColumn2);
            groupSummaryRow1.SummaryColumns.Add(summaryColumn3);
            this.sfDataGrid.GroupSummaryRows.Add(tableSummaryRow1);

            //CaptionSummary Row
            GridSummaryRow captionSummaryRow = new GridSummaryRow();
            captionSummaryRow.Name = "CaptionSummary";
            captionSummaryRow.ShowSummaryInRow = true;
            captionSummaryRow.Title = "Caption Summary: Count - {OrderID} - Price - {Price} - Avg Quantity - {Quantity}";

            captionSummaryRow.SummaryColumns.Add(summaryColumn1);
            captionSummaryRow.SummaryColumns.Add(summaryColumn2);
            captionSummaryRow.SummaryColumns.Add(summaryColumn3);
            this.sfDataGrid.CaptionSummaryRow = captionSummaryRow;
        
            
            //ShowRowInSummary = False

            ////Creating Summary Columns
            //GridSummaryColumn summaryColumn1 = new GridSummaryColumn();
            //summaryColumn1.Name = "OrderID";
            //summaryColumn1.SummaryType = SummaryType.CountAggregate;
            //summaryColumn1.Format = "{Count}";
            //summaryColumn1.MappingName = "OrderID";

            //GridSummaryColumn summaryColumn2 = new GridSummaryColumn();
            //summaryColumn2.Name = "Price";
            //summaryColumn2.SummaryType = SummaryType.DoubleAggregate;
            //summaryColumn2.Format = "{Sum}";
            //summaryColumn2.MappingName = "UnitPrice";

            //GridSummaryColumn summaryColumn3 = new GridSummaryColumn();
            //summaryColumn3.Name = "Quantity";
            //summaryColumn3.SummaryType = SummaryType.DoubleAggregate;
            //summaryColumn3.Format = "{Average}";
            //summaryColumn3.MappingName = "Quantity";

            ////TableSummary Row
            //GridTableSummaryRow tableSummaryRow1 = new GridTableSummaryRow();
            //tableSummaryRow1.Name = "TableSummary";
            //tableSummaryRow1.ShowSummaryInRow = false;
            //tableSummaryRow1.Position = VerticalPosition.Bottom;

            //tableSummaryRow1.SummaryColumns.Add(summaryColumn1);
            //tableSummaryRow1.SummaryColumns.Add(summaryColumn2);
            //tableSummaryRow1.SummaryColumns.Add(summaryColumn3);
            //this.sfDataGrid.TableSummaryRows.Add(tableSummaryRow1);

            ////GroupSummary Row
            //GridSummaryRow groupSummaryRow1 = new GridSummaryRow();
            //groupSummaryRow1.Name = "GroupSummary";
            //groupSummaryRow1.ShowSummaryInRow = false;

            //groupSummaryRow1.SummaryColumns.Add(summaryColumn1);
            //groupSummaryRow1.SummaryColumns.Add(summaryColumn2);
            //groupSummaryRow1.SummaryColumns.Add(summaryColumn3);
            //this.sfDataGrid.GroupSummaryRows.Add(tableSummaryRow1);

            ////CaptionSummary Row
            //GridSummaryRow captionSummaryRow = new GridSummaryRow();
            //captionSummaryRow.Name = "CaptionSummary";
            //captionSummaryRow.ShowSummaryInRow = false;

            //captionSummaryRow.SummaryColumns.Add(summaryColumn1);
            //captionSummaryRow.SummaryColumns.Add(summaryColumn2);
            //captionSummaryRow.SummaryColumns.Add(summaryColumn3);
            //this.sfDataGrid.CaptionSummaryRow = captionSummaryRow;
        }

    }


}

